﻿using Microsoft.AspNetCore.Mvc.RazorPages; // PageModel.
using Northwind.ModeleEncji; // Employee, KontekstNorthwind.

namespace NoweFunkcje.Pages;

public class ListaPracownikowPageModel : PageModel
{
  private KontekstNorthwind _db;

  public ListaPracownikowPageModel(KontekstNorthwind db)
  {
    _db = db;
  }

  public Employee[] Pracownicy { get; set; } = null!;

  public void OnGet()
  {
    ViewData["Tytul"] = "Northwind - Pracownicy";

    Pracownicy = _db.Employees.OrderBy(e => e.LastName)
      .ThenBy(e => e.FirstName).ToArray();
  }
}